/* Formats and Prints Function Arguments and Return values */

/* This file is a disaster */


void initialize_func_args(func_args* fargs);
void copy_func_args(func_args* src, func_args* dst);
void set_func_args(func_args* fargs);
int is_num(unsigned long value);
int is_other(unsigned long value);
int is_char(unsigned long value);
int is_print_char(unsigned long value);
int is_addr(unsigned long value);
int is_func_space(unsigned long value);
int do_string(long value, int num);
int print_string(long value, int num);
void print_long(long value);
int print_value(long value, int num);
int check_verbose_args(func_args* fargs);
int new_to_old_args(func_args* new, func_args* old);
void print_args();


// Set everything equal to zero
void initialize_func_args(func_args* fargs)
{    
    for(fargs->used=MAXARGS;fargs->used>=0;fargs->used--)
        fargs->arguments[fargs->used] = 0;
    fargs->function_num = -1;

}

void copy_func_args(func_args* src, func_args* dst)
{
    //dst = src;
    int i;
    for(i = 0; i <= MAXARGS; i++)
        dst->arguments[i] = src->arguments[i];
        
    dst->function_num = src->function_num;
    dst->used = 1;
}

void set_func_args(func_args* fargs)
{
    int i;
    for(i = 0; i <= MAXARGS; i++)
        fargs->arguments[i] = PEEK(cl->child_pid,save_regs.esp+(4*(i+1)));
        
    fargs->function_num = address_to_function(save_regs.eip);
        
    fargs->used = 1;
        
}

int is_num(unsigned long value)
{
    //Anything under STARTELF is probably a direct value
    if (value >= STARTELF)
        return 0;   
    return 1;

}

int is_other(unsigned long value)
{
    if ((value > last_func_addr) && (value < save_regs.esp))
        return 1;
    return 0;
}

int is_char(unsigned long value)
{
    return isascii((char)value);
}

int is_print_char(unsigned long value)
{
    return (isgraph((char)value) || (char)value == ' ');        
}

int is_addr(unsigned long value)
{
    //Stack grows down, so check from bottom of stack to top
    if ((value >= save_regs.esp) && (value <= TOPSTACK))
        return 1;        
    return 0;
}

int is_func_space(unsigned long value)
{
    if ((value >= STARTELF) && (value <= last_func_addr))
        return 1;
    return 0;
}

//This breaks a long value into 4 characters
int do_string(long value, int num)
{
    while (value > 0)
    {  
        if ((char)value == 0x0) return 0;          
        if (isgraph((char)value) || (char)value == ' ')
            fprintf(cl->out_stream,"%c",(char)value);
        else fprintf(cl->out_stream,"\\%03x",(unsigned char)value);
        value = value>>8;
        if (num--==0) //We printed out num characters, so return
        {
            fprintf(cl->out_stream,"...");
            return 0; 
        }
    }
    return 1;
}

int print_string(long value, int num)
{   
    int i;
    long saveval = value;
    
    for(i = 0; i < num; i++)
    {
        value = saveval;
        value = PEEK(cl->child_pid,value+(4*i));
        if ((char)value==0) return 1; //Null string, return 1
        
        if (do_string(value,num)==0)
            return 0;
    }
    fprintf(cl->out_stream,"...");
    return 0;
}

void print_long(long value)
{
    if (value < TOOLARGE) // print as regular integer if it's small enough
        fprintf(cl->out_stream,"%li",value);
    else // otherwise print hex for large values
        fprintf(cl->out_stream,"0x%lx",value);
        
    //Is it a possible char/string value?
    if (is_print_char(value))
    {
        fprintf(cl->out_stream,"(");
        do_string(value,MAXSTRING);
        fprintf(cl->out_stream,")");
        //fprintf(cl->out_stream,"[char c=%c] ",(char)value);
    }
}

/* this will be a complicated function with a lot of assumes */
// value = value to print, num = number of value types
int print_value(long value, int num)
{
/* 
    Go from smallest value to largest value 
*/

    //We don't really know what type value is, so print out all guessed types
    if (value==0) // Is it NULL? 
    {
        fprintf(cl->out_stream,"0");
        return 1;
    }
    else if (is_num(value))// Is it a direct value (integer)?
    {
        print_long(value);
    }
    else if (is_func_space(value)) // Is it a pointer to a function?
    {
        //fprintf(cl->out_stream,"");
        //cl->show_eip may be off, so temporary enable it
        if ((cl->show_eip & 2)!=2)
        {
            cl->show_eip |= 2;        
            print_addr(value);   
            cl->show_eip ^= 2;
        }
        else
            print_addr(value);
    }
    else if (is_other(value)) // This will be things like floats
    {
        fprintf(cl->out_stream,"?->0x%lx",value);
        //return 1; /* usually a good sign we can stop printing stuff */
    }
    else if (is_addr(value)) // Is is a pointer? 
    {             
        int i; int test;
        long saveval = value;
        long oldval = 0;
        fprintf(cl->out_stream,"*0x%lx:",value);
        
        //Pointer could be to an array
        for(i = 0; i < MAXARRAY; i++)
        {
            value = saveval;
            fprintf(cl->out_stream," {%i}",i);
            
            // Might be some *(*) business, recurse until we get a value
            while (is_addr(PEEK(cl->child_pid,value+(4*i))))
            {
                value = PEEK(cl->child_pid,value+(4*i));
                fprintf(cl->out_stream,"->0x%lx",value);            
            }
            
            //To keep the same string from being printed multiple times
            if (value == oldval)
            {
                fprintf(cl->out_stream,"[<]"); 
                break; //continue
            }            
            oldval = value;            
            
            fprintf(cl->out_stream,"[");
            //value is still a pointer
                       
            if (is_print_char(PEEK(cl->child_pid,value)))
            {

                test=print_string(value, MAXSTRING);
                fprintf(cl->out_stream,"]");
                /*
                if (test==1) //Empty String
                {
                    fprintf(cl->out_stream,"\\0");
                    return 0;
                }
                */
            }
            else if (is_num(PEEK(cl->child_pid,value)))
            {
                if (PEEK(cl->child_pid,value) == 0)
                {
                    fprintf(cl->out_stream,"]");
                    return 0;                
                }
                print_long(PEEK(cl->child_pid,value));
                fprintf(cl->out_stream,"]");
            }
            else
            {
                fprintf(cl->out_stream,"]");
                return 0;
            }
            
        }
    }
    else
    {
        fprintf(cl->out_stream,"#->0x%lx",value);
        return 1;
    }

    return 0;
}

/* check to see if args repeat themselves, return number of good args */
int check_verbose_args(func_args* fargs)
{
    int i, j;
    for(i = 0; i <= MAXARGS-2; i++)
        for(j = i+2; j <= MAXARGS; j++)
            //fprintf(cl->out_stream,"0x%lx == 0x%lx\n",fargs->arguments[i],fargs->arguments[j]);
            if (fargs->arguments[i] == fargs->arguments[j])
                if (fargs->arguments[i+1] == fargs->arguments[j+1])
                    return j-1;
        
    return MAXARGS;
}

/* Checks to see if new arguments have some copy of some previous
   old arguments from another function, if it does we don't want to show those
   arguments again
   
   if the functions are the same, then don't worry
*/
int new_to_old_args(func_args* new, func_args* old)
{
    int i, j;

    //No current or previous arguments
    if (new == NULL || old == NULL)
        return MAXARGS;
    //If they are the same function, it's okay to repeat args
    if (new->function_num == old->function_num)
        return MAXARGS;
        
    for(i = 0; i <= MAXARGS-1; i++)
    {
        for(j = 0; j <= MAXARGS-1; j++)
        {
            if (old->arguments[i] == new->arguments[j])
            {
                if (old->arguments[i+1] == new->arguments[j+1])
                    return j-1;
            }
        }
    }
        
    
        
    return MAXARGS;
}



void print_args()
{
/* Arguments are pushed on the stack **********************************************
   esp+4 will always be the first argument */
   
    /* We could write a nice check that writes each call stack to
     it's own file called function.pid */

    /* DUH! malloc any structure you get */
    int to_print = MAXARGS;     
    func_args* current_args = (func_args*) malloc(sizeof(func_args));
    
    set_func_args(current_args);
    
    //Make sure that arguments themselves don't repeat in the call
    to_print = check_verbose_args(current_args);
    
    //Check if current_args are exactily like prev_args
    //if they are, then we don't need to print them out again
    int to_print2 = new_to_old_args(current_args, prev_args);
    
    // Get the smaller of the two argument count
    if (to_print2 < to_print)
        to_print = to_print2;
        
    //Any way to determine how many arguments a function really has?
    //fprintf(cl->out_stream,"[0x%0lx|0x%0lx](",save_regs.esp,save_regs.ebp);
     
    int i;
    fprintf(cl->out_stream,"(");
    for(i = 0; i <= to_print; i++)
    {
        if (print_value(current_args->arguments[i],MAXARRAY)==1)
            break;
        //fprintf(cl->out_stream,"%i: 0x%0lx ",i,save_regs.esp+(4*(i+1)));
        if (i!=to_print) fprintf(cl->out_stream,", ");
        
    }
    fprintf(cl->out_stream,")");
    
    if (prev_args == NULL)
    {
        prev_args = (func_args*) malloc(sizeof(func_args));
    }
    copy_func_args(current_args, prev_args);
    free(current_args);
     
     
/*
    fprintf(cl->out_stream,"[0x%0lx|0x%0lx](",save_regs.esp,save_regs.ebp);
    //fprintf(cl->out_stream,"\n\ta1:");
    print_value(PEEK(cl->child_pid,save_regs.esp+4),MAXSTRING);
    fprintf(cl->out_stream,", ");
    //fprintf(cl->out_stream,"\n\ta2:");
    print_value(PEEK(cl->child_pid,save_regs.esp+8),MAXSTRING);
    fprintf(cl->out_stream,", ");
    //fprintf(cl->out_stream,"\n\ta3:");
    print_value(PEEK(cl->child_pid,save_regs.esp+12),MAXSTRING);
    fprintf(cl->out_stream,", ");
    //fprintf(cl->out_stream,"\n\ta4:");
    print_value(PEEK(cl->child_pid,save_regs.esp+16),MAXSTRING);
    fprintf(cl->out_stream,", ");
    //fprintf(cl->out_stream,"\n\ta5:");
    print_value(PEEK(cl->child_pid,save_regs.esp+20),MAXSTRING);
    fprintf(cl->out_stream,", ");
    print_value(PEEK(cl->child_pid,save_regs.esp+24),MAXSTRING);
    fprintf(cl->out_stream,")");
*/
}

